/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include <windows.h>
#include "../common/graphics/gl_image.h"
#include "../common/graphics/gl_win.h"


//-------------------------------
//  O[XP[ւ̕ϊW
//-------------------------------

//---   NTSC (W 1000 {j  ---
const int cR = 299;
const int cG = 587;
const int cB = 114;



static image img, imgAnaglyph;
static int w, h;


void
make_anaglyph_left()
{
	GLint  viewport[4];
	glGetIntegerv( GL_VIEWPORT, viewport );
	w = viewport[2];
	h = viewport[3];




	img.alloc(w,h,3);
	imgAnaglyph.alloc(w,h,3);

	// Read Pixels
	GLubyte* p0 = (GLubyte*)img.get_pointer();
	glReadPixels(0, 0, w, h, GL_RGB, GL_UNSIGNED_BYTE, p0);


	GLubyte* p  = img.get_pointer();
	GLubyte* pa = imgAnaglyph.get_pointer();
	const int imax = w * h;
	for (int i=0; i<imax; i++) {
		int lv = (cR*p[0] + cG*p[1] + cB*p[2])/1000;
		GLubyte val = GLubyte(lv);
		pa[0] = val;		// R-channel
		p  += 3;
		pa += 3;
	}
}


void
make_anaglyph_right()
{
	GLubyte* p0 = (GLubyte*)img.get_pointer();
	glReadPixels(0, 0, w, h, GL_RGB, GL_UNSIGNED_BYTE, p0);


	GLubyte* p  = img.get_pointer();
	GLubyte* pa = imgAnaglyph.get_pointer();
	const int imax = w * h;
	for (int i=0; i<imax; i++) {
		int lv = (cR*p[0] + cG*p[1] + cB*p[2])/1000;
		GLubyte val = GLubyte(lv);
		
		pa[1] = val;
		pa[2] = val;
		p  += 3;
		pa += 3;
	}


	// Draw Pixels
	gl_enter_2D_mode();
		glRasterPos2i(0,h-1);
		glPixelZoom(1,1);
		glDrawPixels(w, h, GL_RGB, GL_UNSIGNED_BYTE, (GLubyte*)imgAnaglyph.get_pointer());
	gl_leave_2D_mode();
}
