/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#ifndef  __CELE_MECH_H__
#define  __CELE_MECH_H__
#include  "../math/vector3.h"
#include  "../JulianDate.h"


//----------------------------------------------
//  Öʒu߂iOWnFœ__j
//    a:  Oa
//    e:  S
//    M0: ϋߓ_piAxj
//    n:  ω^ixAPʎԂj
//    epoch: 
//    t:  ʒu߂鎞
//----------------------------------------------
vector3d	calc_orbital_pos(const double& a, const double& e, const double& M0, const double& n, const JD& epoch, const JD& t);


//---------------------------------------------------
//  Q̍WԂ̕ϊ
//---------------------------------------------------
//   node: _o, i: OXΊp, omg: ()_
//  * px͑SēxPʂƂ
//---------------------------------------------------
inline matrix3d
calc_trans_matrix(const double& node, const double& i, const double& omg)
{
	return  Rzxz3(D2R*node, D2R*i, D2R*omg);
}

inline vector3d
calc_pos_on_ref_plane(const double& node, const double i, const double& omg, const vector3d& r)
{
	return  Rzxz3(D2R*node, D2R*i, D2R*omg) * r;
}


#endif
