/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_switches.h"


//
extern bool EarthCityLightsIni;


char tyStereo = STEREO_NONE;

//-------
//  ݒ
//-------
int TexShrinkRate = 1;	// ǂݍݎ̏k

//---------
//  [h
//---------
static char tyLandingMode = LANDING_MODE_HORIZONTAL;
char	get_landing_mode()			{ return tyLandingMode; }
void	set_landing_mode(char mode)	{ tyLandingMode = mode; }


//----------------
//  \pXCb`
//----------------
static  char DispSwitch[DISPSW_NUM];

//---  Init
void
init_disp_switches()
{
	char sw = DISPM_DISP | DISPM_NAME | DISPM_ORBIT | DISPM_CLOUD;
	if (EarthCityLightsIni)  sw |= DISPM_CITY_LIGHTS;
	DispSwitch[ DISPSW_PLANET ]			= sw;
	DispSwitch[ DISPSW_SATELLITE ]		= DISPM_DISP | DISPM_NAME | DISPM_ORBIT | DISPM_SELECT;
	DispSwitch[ DISPSW_MINOR_PLANET ]	= DISPM_DISP | DISPM_NAME | DISPM_ORBIT | DISPM_SELECT;
	DispSwitch[ DISPSW_TNO ]			= DISPM_DISP | DISPM_NAME | DISPM_ORBIT | DISPM_SELECT;
}

//---  Set / Get
void
set_disp_switch(char idx, char val)
{
	DispSwitch[idx] = val;
}

char
get_disp_switch(char idx)
{
	return DispSwitch[idx];
}

bool
test_disp_switch(char idx, char mask)
{
	char sw = DispSwitch[idx];
	return  (sw & mask) != 0;
}

//--  H
char  swEclipse				= ECLIPSE_DISP;
//--  P
char  swStar				= STAR_DISP | STAR_NAME | STAR_NAME_SELECT;
//--  
char  swConstellation		= 0;
//--  
char  swGalaxy				= GLXY_OUR_GALAXY | GLXY_GLOB_CLSTR | GLXY_NEARBY_GALAXY | GLXY_DISTANT_GALAXY | GLXY_QSO;
//-- C
char AtmosphereMode = ATMOSPHERE_MULTIPLE;
//-- XP[
char swScaleLine			= SCALE_CIRCLE;

bool  bSpacecraft			= true;			// T@
bool  bSurfacePointer		= true;			// n\̃|C^
bool  bOortCloud			= true;			// I[g̉_
bool  bVirgoCluster			= false;		// Ƃߍ͒c̃}[N	
bool  bNGC					= false;		// NGCV
bool  bCelestialGrid		= false;		// ԌoEԈ܂̐
bool  bEcliptic				= false;		// 
bool  bHorizonCoord			= false;		// nW
bool  bGalacticGrid			= false;		// oE܂̐
bool  bDate					= true;			// \
bool  bSideLight			= false;		// ̏Ɩ
bool  bSubtitles			= false;		// [h
bool  bAppTitle				= false;		// AvP[Ṽ^Cg
bool  bAbout				= false;		// 
bool  bDebug				= false;		// fobO̕\
bool  bViewInfo				= false;		// _
bool  bSingleEye			= false;		// ЖځiEځjpf̂
bool  bPathInfo				= false;		// pX̕\
bool  bKeyHelp				= false;		// L[{[hwv\
bool  bFPS					= false;		// fps ̕\

//--------------
//  [r[쐬
//--------------
char make_movie_type = MV_AVI;
char mv_filename[256];
char mv_basefilename[256];
